Subject: [tsvwg] L4S ops, RFC 3168 & RFC 8311 (was: Adoption call for draft-white-tsvwg-l4sops - to conclude 24th March 2021)

From: "Black, David" <[email-masked]>
Date: Thu, 25 Mar 2021 15:32:07 +0000

> 	[SM] Fair enough, that is why I proposed to direct readers of rfc3168 to the L4S ops ID and leaving out the redirection via rfc8311.
> The point is, if we are going to encourage/permit end-points to behave in a way that violates the assumptions made by operators
> of rfc3168 AQMs the onus is on us to at least inform them about the fact, and what remedies we came up with.

Hmm - as an author of both RFCs, I'm having mixed reactions to this idea.

On the one hand, RFC 3168 is updated by RFC 8311, which is one of only 3 RFCs that updates RFC 3168, so I think it's reasonable to expect that an implementer of RFC 3168 will look at RFC 8311.

On the other hand, once an implementer looks at RFC 8311,  s/he will see that for L4S, RFC 8311 references only the ecn-l4s-id draft, to which adding a reference to the L4S ops draft may be a good idea.  We can do that and avoid the EXP updates PS problem by submitting errata (an erratum?) directly against RFC 8311 to add a reference to the l4s-ops draft, and perhaps also add some text to cite it.  I think that would work better than asking for a process exception (which the IESG can grant) to directly update RFC 8311 from the L4S ops draft, and has the additional advantage that errata can be applied to RFC 8311 before the L4S ops draft is published as an RFC.

Thanks, --David

-----Original Message-----
From: tsvwg <[email-masked]> On Behalf Of Sebastian Moeller
Sent: Thursday, March 25, 2021 9:20 AM
To: Ingemar Johansson S
Cc: [email-masked]
Subject: Re: [tsvwg] Adoption call for draft-white-tsvwg-l4sops - to conclude 24th March 2021

[EXTERNAL EMAIL] 

Hi Ingemar,

> On Mar 25, 2021, at 14:08, Ingemar Johansson S <[email-masked]> wrote:
> 
> Hi
> 
> One reflection around all this is that it really does not matter how many
> warning signs you put, information may still not reach the intended
> audience. 

	[SM] While potentially true, not really an actionable position to take... We can expect that parties interested in participating n the L4S experiment actually read the relevant L4S RFCs, but if we require others to also change their behavior/configurations/expectations we should take active steps to reach these parties, even if we can not guarantee to reach them all. In short we need to make a good faith effort. At least that is what common sense tells me, is there any relevant RFC instructing us to do otherwise?

> I guess there must be an abundance of cases with other IETF work that does
> not reach the audience, sometimes with suboptimal performance as a result.

	[SM] We are actively contemplating of releasing protocols into the wide internet that run roughshod over rfc3168 and the expected sharing-between-flows properties of deployed AQM. Are you really advocating that we just do what pleases our whims right now, just because doing so is more convenient to us? I am puzzled, truly puzzled.

> And I don't find it too productive to dump a lot of informational text in
> RFC8311 around what can possibly go wrong, especially as it is not fully
> clear how serious these problems really are.

	[SM] Fair enough, that is why I proposed to direct readers of rfc3168 to the L4S ops ID and leaving out the redirection via rfc8311. The point is, if we are going to encourage/permit end-points to behave in a way that violates the assumptions made by operators of rfc3168 AQMs the onus is on us to at least inform them about the fact, and what remedies we came up with.

> Only way forward I see is to
> move on with the L4S experiment and document possible issues as they come.
> The L4S ops draft provide good initial input here and it will likely be
> complemented with more best current practice.

	[SM] Expect my, "I am running roughshod over L4S" ID any time soon, if all I need to do is to document issues... @chairs is this the official position of this WG and of the wider IETF, how to handle such conflicts of interest? I would be amazed if it would be...

Best Regards
	Sebastian

P.S.: I really tried to keep this focussed on how best to get the relevant information into the hands of potentially affected AQM operators; yet it turned again into a side-show about differences in opinion on how safe and sound engineering should be performed. 

> 
> /Ingemar
> 
>> -----Original Message-----
>> From: Sebastian Moeller <[email-masked]>
>> Sent: den 25 mars 2021 12:45
>> To: Ingemar Johansson S <[email-masked]>
>> Cc: Bob Briscoe <[email-masked]>; [email-masked]
>> Subject: Re: [tsvwg] Adoption call for draft-white-tsvwg-l4sops - to
> conclude
>> 24th March 2021
>> 
>> Hi Ingemar,
>> 
>> thanks for responding.
>> 
>>> On Mar 25, 2021, at 12:35, Ingemar Johansson S
>> <[email-masked]> wrote:
>>> 
>>> Sebastian..
>>> 
>>> Isn't the updated by RFC8311 sufficient in RFC3168 ?. It refers to L4S
>>> work, namely the L4S ID which targets experimental standards status.
>> 
>> 	[SM] IMHO not really, rfc8311 has no big warning signs, that those
>> experimental standards are allowed/expected to carry negative side-effects
>> for rfc3168-compliant AQMs and operators of rfc3168 AQM need to employ
>> specific steps to ensure safety/functionality of their AQM to accommodate
>> such experimental standards traffic.
>> 	I am not trying to start a discussion about whether doing that at
> all is
>> a good idea, but how to make sure that information reaches the parties
> that
>> would need to follow those instructions. IMHO the link to rfc8311 does not
>> convey enough urgency for rfc3168 deployers to go digging deeper, but I
>> might be just naive here, not being/working for an operator.
>> 
>>> Also, to me it sounds odd to add an
>>> Updated by : [L4S Ops - Informational RFC] to a proposed standard ? ,
>> 
>> 	[SM] Same sentiment, that why I asked. The information though
>> seems important. If rfc3168 deployers need to do something extra to
>> guarantee their safety and functionality, because of changes somewhere
>> else, I believe the party responsible for those changes (aka this WG)
> should
>> make sure that even casual reads of rfc3168 know about the additional
> steps
>> we expect them to take.
>> 
>> Best Regards
>> 	Sebastian
>> 
>> 
>>> In any case it is the first time in RFC3168's history that it happens,
>>> unless I missed something.
>>> 
>>> /Ingemar
>>> 
>>>> -----Original Message-----
>>>> From: tsvwg <[email-masked]> On Behalf Of Sebastian Moeller
>>>> Sent: den 25 mars 2021 10:40
>>>> To: Bob Briscoe <[email-masked]>
>>>> Cc: [email-masked]
>>>> Subject: Re: [tsvwg] Adoption call for draft-white-tsvwg-l4sops - to
>>> conclude
>>>> 24th March 2021
>>>> 
>>>> Hi Bob,
>>>> 
>>>> 
>>>>> On Mar 25, 2021, at 10:26, Bob Briscoe <[email-masked]> wrote:
>>>>> 
>>>>> Steven,
>>>>> 
>>>>> On 24/03/2021 23:12, Steven Blake wrote:
>>>>>> On Wed, 2021-03-24 at 22:50 +0000, Bob Briscoe wrote:
>>>>>>> Steven,
>>>>>>> 
>>>>>>> 
>>>>>>> On 23/03/2021 00:56, Steven Blake wrote:
>>>>>>>> Sec. 4 (Operator of a Network) of the draft presumes that
>>>>>>>> deployed equipment is capable to classifying packets specifically
> on
>> ECT(1).
>>>>>>>> Have the authors confirmed that this feature is available on
>>>>>>>> commonly deployed operator gear (e.g., IOS-XR, JUNOS)?
>>>>>>> [BB]
>>>>>>> (Aside: I think you're reading an old (-01) draft. That section
>>>>>>> has been Sec. 5. since draft-02 on 22 Feb 2021.
>>>>>>> See my response to the initial adoption call about the probable
>>>>>>> cause of this confusion - suspected problems with the IETF tools
>>>>>>> servers.
>>>>>>> )
>>>>>> Oops! You're right. s/Sec. 4/Sec. 5.
>>>>>> 
>>>>>> 
>>>>>>> To your point, I checked the manuals of one or two OSs of common
>>>>>>> makes of router before I proposed the WRED technique for addition
>>>>>>> to the draft. And I discussed the hardware capabilities with
>>>>>>> people within one or two router vendors. In the cases I checked,
>>>>>>> the CLI limits the flexibility that the admin has to define
>>>>>>> classifiers as general bit patterns. However the hardware
>>>>>>> underneath does have that flexibility.
>>>>>>> So
>>>>>>> this would require a CLI update for the routers I checked. The
>>>>>>> Linux classifier architecture does provide sufficient flexibility
>>>>>>> for such a classifier.
>>>>>>> 
>>>>>>> I also suggested the ECT(1) tunnel bypass technique, but I didn't
>>>>>>> exhaustively check the manuals of all the different types of
>>>>>>> tunnel (there are dozens).
>>>>>>> 
>>>>>>> I think this list of techniques is most useful for router
>>>>>>> developers, who can then find the easiest and most efficient one
>>>>>>> for their particular kit; whether they have to update the CLI, or
>>>>>>> whether they can find a way for their users to configure their
>>>>>>> unmodified systems in the field.
>>>>>> 
>>>>>> So operators that *don't wish to participate in L4S experiments*
>>>>>> may need to update *their* deployed software? Ask your favorite
>>>>>> router vendor how many customer-specific releases they are
>>>>>> maintaining because customers don't want to move forward once they
>>>>>> get a working validated release.
>>>>> 
>>>>> [BB] There is a common belief that, if any RFC3168 FIFO AQMs exist,
>>>>> they
>>>> will be rare. But Jake and Jonathan raised the concern that it still
>>>> needs
>>> to be
>>>> possible to deploy RFC3168 routers from now onwards. In that case,
>>>> operators that *don't wish to participate* would be updating their
>>>> config, and l4sops then gives router developers ideas for how they
>>>> might be able
>>> to
>>>> prevent an existing implementation of RFC3168 from acting on ECT(1),
>>>> given an ECN implementation is likely to be hard-coded against the
>>>> ECN codepoints.
>>>> 
>>>> 
>>>> 	[SM] This asks the question, how would an operator that is about to
>>>> enable an rfc3168 AQM know that he better read and follow the L4S-ops
>>>> ID/RFC? Are we expecting all operators to read and follow all RFCs
>>>> meticulously all the time?
>>>> 	IMHO an operator intending on employing an rfc3168 AQM might
>> read
>>>> RFC3168 and RFCs referenced from there (which is IMHO already less
>>>> likely), while an operator interested in L4S might read all of the
>>>> L4S
>>> IDs/RFCs.
>>>> But here we would need the rfc3168 deploying operators to read and
>>>> follow an L4S ID/RFC...
>>>> 	I guess adding an updated by to rfc3168 pointing to the L4S-ops RFC
>>>> might offer a solution, but can/should a informational RFC update a
>>>> PS document (honest question, I am just not sure about whether our
>>>> process permits that)?
>>>> 
>>>> Best Regards
>>>> 	Sebastian
>>>> 
>>>> P.S.: This is basically the same issue I have with the only mildly
>>>> related
>>> NQB
>>>> ID: in both contexts, we seem to expect parties genuinely not
>>>> interested
>>> in
>>>> the topic of the ID to act in a specific way to accommodate either
>>>> the NQB
>>> or
>>>> the L4S IDs/RFCs. And in both cases arguably bad things happen if
>>>> those parties do not follow the recommendations.
>>>> 
>>>> 
>>>>> 
>>>>> 
>>>>> 
>>>>> Bob
>>>>> 
>>>>>> 
>>>>>> 
>>>>>> Regards,
>>>>>> 
>>>>>> // Steve
>>>>>> 
>>>>>> 
>>>>>> 
>>>>>> 
>>>>> 
>>>>> --
>>>>> 
>>>> 
>> __________________________________________________________
>>>> ______
>>>>> Bob Briscoe
>>>> https://protect2.fireeye.com/v1/url?k=532c5e52-0cb76757-532c1ec9-
>>>> 86d2114eab2f-53274140f9ce9692&q=1&e=8a9723d1-2c84-4bf6-b7d7-
>>>> b62af3457d9a&u=http%3A%2F%2Fbobbriscoe.net%2F
>>> 
>

---

From: Sebastian Moeller <[email-masked]>
Date: Thu, 25 Mar 2021 17:26:03 +0100

Hi David,

thanks for your thoughts.

> On Mar 25, 2021, at 16:32, Black, David <[email-masked]> wrote:
> 

	[SM] My main concern is to get the right information into the right hands, not so much about the how.

> On the one hand, RFC 3168 is updated by RFC 8311, which is one of only 3 RFCs that updates RFC 3168, so I think it's reasonable to expect that an implementer of RFC 3168 will look at RFC 8311.

	[SM] With implementer, we are talking about someone putting an rfc3168-compliant AQM into service, or someone creating a new rfc3168 AQM from scratch? I assume the former, just asking to get the nomenclature correct.

> 
> On the other hand, once an implementer looks at RFC 8311,  s/he will see that for L4S, RFC 8311 references only the ecn-l4s-id draft, to which adding a reference to the L4S ops draft may be a good idea.

	[SM] +1; if we believe rfc3168 operators need to read the ops draft we should make that easy to find ;), or even better hard to ignore.

>  We can do that and avoid the EXP updates PS problem by submitting errata (an erratum?) directly against RFC 8311 to add a reference to the l4s-ops draft, and perhaps also add some text to cite it.  I think that would work better than asking for a process exception (which the IESG can grant) to directly update RFC 8311 from the L4S ops draft, and has the additional advantage that errata can be applied to RFC 8311 before the L4S ops draft is published as an RFC.

	[SM] I happily defer to your experience and process knowledge. I am still puzzled how operators of existing rfc3168 AQM can be informed, but I guess a first step would be to make new deployments aware of the issue.

Thanks a lot & Best Regards
	Sebastian

---

From: "Black, David" <[email-masked]>
Date: Thu, 25 Mar 2021 17:40:55 +0000

Hi Sebastian,

Responding to this small item:

> > ... an implementer of RFC 3168 will look at RFC 8311.
> 
> 	[SM] With implementer, we are talking about someone putting an rfc3168-compliant AQM into service,
>	or someone creating a new rfc3168 AQM from scratch? I assume the former, just asking to get the nomenclature correct.

Definitely the latter, but the former, "someone putting an rfc3168 AQM into service," covers a spectrum that ranges from the parent who buys a better WiFi access point because the kids are complaining about the Internet being slow to a sophisticated network operator who is rolling out a well-planned infrastructure upgrade.   As one moves towards the latter end of the range, I'd think that RFC 3168 is more likely to be consulted.

Thanks, --David

-----Original Message-----
From: Sebastian Moeller <[email-masked]> 
Sent: Thursday, March 25, 2021 12:26 PM
To: Black, David
Cc: Ingemar Johansson S; [email-masked]
Subject: Re: L4S ops, RFC 3168 & RFC 8311 (was: Adoption call for draft-white-tsvwg-l4sops - to conclude 24th March 2021)

[EXTERNAL EMAIL] 

Hi David,

---

From: Gorry Fairhurst <[email-masked]>
Date: Thu, 25 Mar 2021 18:35:23 +0000

> Definitely the latter, but the former, "someone putting an rfc3168 AQM into service," covers a spectrum that ranges from the parent who buys a better WiFi access point because the kids are complain…

Wait a minute, if you do buy an AP with RGFC3168 ECN turned on by 
default, then do just return the box! This RFC 3168-enabled box will not 
help. L4S might, or FQ, or both!

Seriously, this AP seems to me to be unlikely to compromise the Internet 
Infrastructure, I don't fear Internet collapse from this use case.

Gorry (strictly as an individual)

---

From: Sebastian Moeller <[email-masked]>
Date: Thu, 25 Mar 2021 20:15:01 +0100

Hi David.

> On Mar 25, 2021, at 18:40, Black, David <[email-masked]> wrote:
> 
> Hi Sebastian,
> 

	[SM] So I admit, when we set the ECN defaults for sqm-scripts, I dd not consult any RFCs at all. Yes, I had read rfc3168 some time before, but I did not assume that I would have to do any reseach at all before simply enabling options in Linux qdiscs (like ecn for fq_codel). I think your staged continuum model is a realistic model though. But I have a hunch, that it is hard to retroactively change the conditions under which to deploy something. But no matter that, let's make the ops draft more prominent, if L4S safety depends on it (which it does even though it should not ;) )

Best Regards
	Sebastian

---

From: Sebastian Moeller <[email-masked]>
Date: Thu, 25 Mar 2021 20:22:55 +0100

Hi Gorry,

> On Mar 25, 2021, at 19:35, Gorry Fairhurst <[email-masked]> wrote:
> 
> Wait a minute, if you do buy an AP with RGFC3168 ECN turned on by default, then do just return the box!

	[SM] That isn't how that works. You buy an off the shelf router, than re-flash with OpenWrt and then install sqm-scripts on top of that. That gives you an rfc3168 AQM that is actually battlehardened and real-life tested.

> This RFC 3168-enabled box will not help.
> L4S might, or FQ, or both!

	[SM] Well that rfc3168 is FQ (either fq_codel or cake), and it does help immediately, because unlike L4S it will work with the existing mix of protocols used in the internet. For all normal users dploying L4S today will just buy them a shitty version of ECN-PIE with a single queue, so exactly the config you just ridiculed... I wish L4S proponents would actually eat their own dog-food, that is employ that on their own home link for a month and then compare this with less experimental competitors like sqm-scripts, before embarking on making recommendations what end users should do...
	Okay, I guess, yiu were trynig to joke here, but this is not terribly funny.

> 
> Seriously, this AP seems to me to be unlikely to compromise the Internet Infrastructure, I don't fear Internet collapse from this use case.

	[SM] If by accident an L4S flow runs over that link, the internet access for that link might effectively collapse (see L4S abysmal sharing behavior between the two queues if the RTTs are not stacked against L4S).

But this is a bit of a side-show, if L4S-OPs is important for rfc3168 users we need to find a way to learn about this as effortlessly as possible.

Best Regards
	Sebastian